from mpl_toolkits.basemap import Basemap    
import numpy as np
import matplotlib.pyplot as plt
from pylab import *

# FUNCTIONS .   
def drawmap(Meta, fname, N, fpath, Blankdis, Date, Longnew, Latnew, VXnew, VYnew, opt):
    
    # Necesitamos una variable Basemap m para hacer la conversion de variables.
    m = Basemap(width=12000, height=9000, projection='tmerc',
                resolution='c', lat_1=40.6, lat_2=40.65, lat_0=40.625,  lon_1=0.5 ,lon_2=0.8,  lon_0=0.7)        
           
# Obtenemos la maxima latitud y su longitud asociada.    
    maxlat= max(Meta.GPS.LAT);   
    ind_latmax = np.where(Meta.GPS.LAT == maxlat)      
    a = float(Meta.GPS.LON[ind_latmax])
# Convert to map projection coords. xpt,ypt = m(lon,lat). 
    xpt1,ypt1 = m(a,maxlat)
    
# Obtenemos la minima latitud y su longitud asociada.      
    minlat = min(Meta.GPS.LAT);    
    ind_latmin = np.where(Meta.GPS.LAT == minlat)      
    b = float(Meta.GPS.LON[ind_latmin]) 
# Convert to map projection coords. xpt,ypt = m(lon,lat). 
    xpt2,ypt2 = m(b,minlat)

# Obtenemos la maxima longitud y su latitud asociada.  
    lonmax = max(Meta.GPS.LON);   
    ind_lonmax = np.where(Meta.GPS.LON == lonmax)      
    c = float(Meta.GPS.LAT[ind_lonmax])
# Convert to map projection coords. xpt,ypt = m(lon,lat). 
    xpt3,ypt3 = m(lonmax,c)
  
# Obtenemos la minima longitud y su latitud asociada. 
    minlon = min(Meta.GPS.LON);  
    ind_minlon = np.where(Meta.GPS.LON == minlon)      
    d = float(Meta.GPS.LAT[ind_minlon])
# Convert to map projection coords. xpt,ypt = m(lon,lat). 
    xpt4,ypt4 = m(minlon,d)  
    
# Obtengo la mayor de las distancias para obtener las dimensiones del mapa.
    heigh = ypt1 - ypt2;
    width = xpt3 - xpt4;   
    d = max(heigh, width)
    
# Proporciones del mapa a 3/4.   width = 4/3*heigh. Sobredimensionamos las dos por 3 para que se vea mas que el trayecto. 3 * 4/3 = 4
    Fheight= 3*d;
    Fwidth = 4*d;
    
# Obtenemos la latitud y longitud donde centrar nuestro mapa.
    truelat = minlat+((maxlat-minlat)/2)
    truelon = minlon+((lonmax-minlon)/2)

# setup Transverse Mercator Projection. 
    m = Basemap(width=Fwidth, height=Fheight, projection='tmerc',
            resolution='c', lat_0=truelat,   lon_0=truelon)  
            
    # Convert trajectory to map projection coords. xpt,ypt = m(lon,lat). 
    xpT,ypT = m(Meta.GPS.LON,Meta.GPS.LAT)
            
    m.plot(xpT,ypT,linewidth=1.5,  color='r')  

    # draw coastlines.
    m.drawcoastlines()    
    # draw a boundary around the map, fill the background. this background will end up being the ocean color, since the continents will be drawn on top.
#    m.drawmapboundary(fill_color='aqua')    
    m.drawmapboundary(fill_color='#99ffff')
    # fill continents, set lake color same as ocean color.
    m.fillcontinents(color='coral',lake_color='aqua')     
    # draw meridians and parallels 
    a1 = int(Meta.GPS.LON[ind_latmax])    
    c1 = int(Meta.GPS.LAT[ind_lonmax])
    # labels = [left,right,top,bottom]
    m.drawmeridians(np.arange(a1-2,a1+2.,.1), labels=[0,0,0,1])
    m.drawparallels(np.arange(c1-1.,c1+1.,.1), labels=[1,1,0,0])       
  
    plt.title('('+ Date +')\n''AUV Trajectory & Vx VY Vect ' +'Profile: '+ opt)   
    
    # Convert to np array in order to make up for transform_vector
    VXnew =np.array([VXnew])
    VYnew =np.array([VYnew])
    Longnew =np.array([Longnew])
    Latnew =np.array([Latnew])
    
#    print min(Longnew)
#    print min(Longnew)
#    print Longnew
#    print Latnew    
    
    xv, yv  = m(Longnew,Latnew) 
    udat, vdat = m(VXnew,VYnew)   
  
    # udat, vdat, xv, yv = m.transform_vector(VXnew,VYnew,Longnew,Latnew,51,51,returnxy=True,  masked =True)
    # plot vectors over map.
    
    Q = m.quiver(xv,yv,udat,vdat, angles='xy', scale=3000, units='width',   color ='black')     #or specify, e.g., width=0.003, scale=400)
    qk = plt.quiverkey(Q, 0.95, 1.05, 1, '1 m/s', labelpos='W',  color ='r') 
    
#     units='width', scale=3000,
    
#    q = m.quiver(Longnew, Latnew, VXnew, VYnew, angles='xy',  units='width', scale=0.5,   latlon ='True',  color='r')    
#    quiverkey(q,40,40.65,100,"100 m/s",coordinates='data',color='r')
        
     
#   width = 0.000022   
#   color = 'r' 
#   scale = 1/0.15   
#   scale  = 5  El mapa disminuye y los vectores aumentan
#   quiver( X, Y, U, V, M, units='x', pivot='tip', width=0.022, scale=1/0.15)        
#   width = 0.0001,   
#   scale = 50    
# Depth? o coloreo por Cells?   
    plt.show()    
    
    return m
